#include <msp430g2253.h>
#include"chuan12864.h"
#include"lsysinit.h"

uchar ircode[4];
uchar irdate[33];
uchar a,num,temp,irok,irpro_ok,startflag;
uchar disp[];


void timer_a_init()          //ʱAʼ
{
    TACTL|=TASSEL1+ID_3+TACLR+MC_1;
    TACCTL0=CCIE;
    TACCR0=256;
}

void ircrodpro()		//ֵ봦
{
    uchar i,j,k,cord,value;
	k=1;
	for(i=0;i<4;i++)
	{
       for(j=0;j<8;j++)
	   {
	      cord=irdate[k];
              value=value>>1;
		  if(cord>7)
		  {
		     value=value|0x80;
		  }
		  k++;
	   }
	   ircode[i]=value;
	   value=0;
    }
	irpro_ok=1;
}

void port_init()
{
   P1DIR&=0XFB;       //P1.0Ϊжʹλ
   P1IE=0x04;
   P1IES=0X04;
   P1IFG=0;
}

void ir_work()
{
    switch(ircode[2])
    {
    case 0x00:temp=1;break;
    case 0x01:temp=2;break;
    case 0x02:temp=3;break;
    case 0x03:temp=4;break;
    case 0x04:temp=5;break;
    case 0x05:temp=6;break;
    case 0x06:temp=7;break;
    case 0x07:temp=8;break;
    case 0x08:temp=9;break;
    case 0x09:temp=0;break;
    case 0x10:temp='a';break;
    case 0x11:temp='s';break;
    case 0x12:temp='u';break;
    case 0x13:temp='d';break;
    default:temp=0;break;
    }
    if(temp!='u'&&temp!='d'&&temp!='a'&&temp!='s')
     temp+=0x30;
    display_string(0,1,&(temp));
}



void main()
{

    WDTCTL=WDTPW+WDTHOLD;
    InitializeClocks();
    port_init();
    LCD_Init();
    timer_a_init();
    _EINT();
    delay_ms(50);
    while(1)
    {
          if(irok)
	  {
	     ircrodpro();
	     irok=0;
	  }	
	  if(irpro_ok)
	  {
	     ir_work();
             irpro_ok=0;
             startflag=0;
	  }	
    }
}

#pragma vector=TIMER0_A0_VECTOR
__interrupt void timer_a()
{
   num++;
}

#pragma vector=PORT1_VECTOR
__interrupt void port1()
{
 // if(startflag)
 // {
    if(num>33)
    a=0;
    irdate[a]=num;
    num=0;
    a++;
    if(a==33)
    {
	irok=1;
       // flag=1;
	a=0;
    }
 // }
  /*   else
    {
        startflag=1;
        num=0;
    }*/
    P1IFG=0;
}


