
#ifndef key2_h
#define key2_h

#include  <msp430x14x.h>
#define uchar unsigned char
#define uint unsigned int
#define CPU_F ((double)8000000)
#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0))
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0))
/***************ȫֱ***************/
uchar key_val=0;          //żֵ
uchar key_change1;       // 1/0
uchar key_change2;       // 1/0
uchar key_Pressed;      //Ƿ񱻰:1--ǣ0--
uchar key_Flag;         //Ƿѷſ1--ǣ0--


//ü߼ֵֵӳ
uchar key_Map[]={'3','2','1','0'};
/*******************************************
ƣInit_Keypad
    ܣʼɨ̵IO˿
    
ֵ  
********************************************/
void init_keypad(void)
{
    P2DIR =0xf0;       //P2.0~P2.3Ϊ״̬, P2.4~P2.7Ϊ״̬
    P2OUT =0xf0;      // P2.4~P2.7ߵƽ
    key_Flag=0;
    key_Pressed=0;
    key_val=0;
}

/*********************************************
* Check_Key(),鰴ȷϼֵ
*********************************************/
/*******************************************
ƣCheck_Key
    ܣɨ̵IO˿ڣüֵ
    
ֵ  
********************************************/
void check_key()
{
    uchar row ,temp,tmp1;
    tmp1=0x01;
    temp=P2IN;
    for(row=0;row <4;row++)              //ɨ
    {
       if((temp&0x0f)==tmp1)
       {
        key_val=key_Map[row];  // ȡֵ
        return;                         // ˳ѭ
       }
       tmp1<<=1;
    }
}

/*******************************************
ƣKey_Event
    ܣⰴȡֵ
    
ֵ  
********************************************/
void key_event(void)
{
    uchar tmp;
    P2OUT = 0x00;              // P2OUTȫΪ0ȴ
    tmp = P2IN;                 // ȡ p2IN
    if ((key_Pressed == 0x00)&&((tmp & 0x0f) !=0)) //м
    {
        key_Pressed = 1;        // а£key_Pressedʶ
        delay_ms(1);                //
        check_key();            // check_Key(),ȡֵ
    }
    else if ((key_Pressed == 1)&&((tmp & 0x0f) == 0)) //Ѿͷ
    {
        key_Pressed = 0;        // key_Pressedʶ
        key_Flag    = 1;        // key_Flagʶ
    }
    else
    {
        _NOP();
    }
}



char KeyCodeConvert (uchar m)
{
  if(m=='3')
    return 'U';
  if(m=='2')
    return 'D';
  if(m=='0')
    return 'E';
  if(m=='1')
    return 'C';
  else
    return 0;
}

#endif